Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/BasesView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/BasesView.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/BasesView.java	(revision 2731)
@@ -75,19 +75,18 @@
  * 
  */
 public class BasesView extends ViewPart {
-		
+	
 	/** The tv. */
 	TreeViewer tv;
-
+	
 	/** The ID. */
 	public static String ID = BasesView.class.getName();
-
+	
 	/**
 	 * Instantiates a new bases view.
 	 */
-	public BasesView() {
-	}
-
+	public BasesView() {}
+	
 	/**
 	 * Refresh.
 	 */
@@ -98,7 +97,7 @@
 		if (baseView != null)
 			baseView.tv.refresh();
 	}
-
+	
 	/**
 	 * Reload.
 	 */
@@ -109,7 +108,7 @@
 		if (baseView != null)
 			baseView._reload();
 	}
-
+	
 	/**
 	 * _reload.
 	 */
@@ -119,8 +118,9 @@
 		tv.setInput(Toolbox.workspace);
 		refresh();
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
 	 */
 	@Override
@@ -129,28 +129,31 @@
 		tv.setContentProvider(new TxmObjectTreeProvider());
 		tv.setLabelProvider(new TxmObjectLabelProvider());
 		tv.setInput(Toolbox.workspace);
-
+		
 		tv.addDoubleClickListener(new IDoubleClickListener() {
-
+			
 			@Override
 			public void doubleClick(DoubleClickEvent event) {
 				TreeSelection selection = (TreeSelection) tv.getSelection();
 				if (selection.getFirstElement() instanceof CQPCorpus) {
-					CQPCorpus corpus = (CQPCorpus)selection.getFirstElement();
-					File selectedItem = new File(corpus.getProjectDirectory(), "cqp/"+corpus.getID()+".cqp");
+					CQPCorpus corpus = (CQPCorpus) selection.getFirstElement();
+					File selectedItem = new File(corpus.getProjectDirectory(), "cqp/" + corpus.getID() + ".cqp");
 					if (selectedItem.exists())
 						EditFile.openfile(selectedItem.getAbsolutePath());
-				} else if (selection.getFirstElement() instanceof Text) {
+				}
+				else if (selection.getFirstElement() instanceof Text) {
 					File selectedItem = ((Text) selection.getFirstElement())
 							.getSource();
 					EditFile.openfile(selectedItem.getAbsolutePath());
-				} else if (selection.getFirstElement() instanceof Edition) {
+				}
+				else if (selection.getFirstElement() instanceof Edition) {
 					Edition edition = ((Edition) selection.getFirstElement());
 					Page firstpage = edition.getFirstPage();
 					TXMBrowser editor = OpenBrowser.openEdition(firstpage
 							.getFile().getAbsolutePath(), edition.getName());
 					editor.showPage(firstpage);
-				} else if (selection.getFirstElement() instanceof Page) {
+				}
+				else if (selection.getFirstElement() instanceof Page) {
 					Page page = ((Page) selection.getFirstElement());
 					TXMBrowser editor = OpenBrowser.openEdition(page.getFile()
 							.getAbsolutePath());
@@ -158,72 +161,74 @@
 				}
 			}
 		});
-
+		
 		tv.getTree().addKeyListener(new KeyListener() {
-
+			
 			@Override
 			public void keyReleased(KeyEvent e) {
 				if (e.keyCode == SWT.DEL) {
 					ISelection sel = tv.getSelection();
 					if (sel instanceof IStructuredSelection) {
-						if (!DeleteObject.askContinueToDelete((IStructuredSelection)sel)) return;
+						if (!DeleteObject.askContinueToDelete((IStructuredSelection) sel)) return;
 						DeleteObject.delete(sel);
 					}
 				}
 			}
-
+			
 			@Override
-			public void keyPressed(KeyEvent e) {
-			}
+			public void keyPressed(KeyEvent e) {}
 		});
-
+		
 		MenuManager menuManager = new MenuManager();
 		Menu menu = menuManager.createContextMenu(tv.getTree());
-
+		
 		// Set the MenuManager
 		tv.getTree().setMenu(menu);
 		getSite().registerContextMenu(menuManager, tv);
 		// Make the selection available
 		getSite().setSelectionProvider(tv);
-
+		
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.part.WorkbenchPart#setFocus()
 	 */
 	@Override
 	public void setFocus() {
 		// TODO Auto-generated method stub
-
+		
 	}
-
+	
 	/**
 	 * The Class TxmObjectLabelProvider.
 	 */
 	public class TxmObjectLabelProvider extends LabelProvider {
-
+		
 		/** The image table. */
-		private Map<ImageDescriptor, Image> imageTable = new HashMap<ImageDescriptor, Image>();
-
-		/* (non-Javadoc)
+		private Map<ImageDescriptor, Image> imageTable = new HashMap<>();
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
 		 */
 		@Override
 		public String getText(Object element) {
 			String title = ((TXMResult) element).getName();
 			if (title.length() > 41) { // limit text length
-				title = title.substring(0, 40)+"..."; 
+				title = title.substring(0, 40) + "...";
 			}
 			return title;
 		}
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.LabelProvider#getImage(java.lang.Object)
 		 */
 		@Override
 		public final Image getImage(Object element) {
 			ImageDescriptor imageDescriptor = AbstractUIPlugin
-					.imageDescriptorFromPlugin(Application.PLUGIN_ID, 
+					.imageDescriptorFromPlugin(Application.PLUGIN_ID,
 							IImageKeys.FILE);
 			if (element instanceof Project)
 				imageDescriptor = AbstractUIPlugin.imageDescriptorFromPlugin(
@@ -240,7 +245,7 @@
 			else if (element instanceof Page)
 				imageDescriptor = AbstractUIPlugin.imageDescriptorFromPlugin(
 						Application.PLUGIN_ID, IImageKeys.FILE);
-
+			
 			Image image = imageTable.get(imageDescriptor);
 			if (image == null) {
 				image = imageDescriptor.createImage();
@@ -249,95 +254,113 @@
 			return image;
 		}
 	}
-
+	
 	/**
 	 * The Class TxmObjectTreeProvider.
 	 */
 	public class TxmObjectTreeProvider implements ITreeContentProvider {
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.ITreeContentProvider#getChildren(java.lang.Object)
 		 */
 		@Override
 		public Object[] getChildren(Object element) {
 			if (element instanceof Workspace) {
 				return ((Workspace) element).getProjects().toArray();
-			} else if (element instanceof Project) {
+			}
+			else if (element instanceof Project) {
 				return ((Project) element).getChildren(MainCorpus.class).toArray();
-			} else if (element instanceof MainCorpus) {
+			}
+			else if (element instanceof MainCorpus) {
 				return ((CQPCorpus) element).getProject().getTexts().toArray();
-			} else if (element instanceof Text) {
+			}
+			else if (element instanceof Text) {
 				return ((Text) element).getEditions().toArray();
-			} else if (element instanceof Edition) {
-				return ((Edition) element).getPages().toArray();
 			}
+			else if (element instanceof Edition) {
+				return ((Edition) element).getPageNames().toArray();
+			}
 			return null;
 		}
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.ITreeContentProvider#getParent(java.lang.Object)
 		 */
 		@Override
 		public Object getParent(Object element) {
 			if (element instanceof Workspace) {
 				return null;
-			} else if (element instanceof Project) {
+			}
+			else if (element instanceof Project) {
 				return ((Project) element).getWorkspace();
-			} else if (element instanceof MainCorpus) {
+			}
+			else if (element instanceof MainCorpus) {
 				return ((MainCorpus) element).getProject();
-			} else if (element instanceof Text) {
+			}
+			else if (element instanceof Text) {
 				return ((Text) element).getProject();
-			} else if (element instanceof Edition) {
+			}
+			else if (element instanceof Edition) {
 				return ((Edition) element).getText();
-			} else if (element instanceof Page) {
+			}
+			else if (element instanceof Page) {
 				return ((Page) element).getEdition();
 			}
 			return null;
 		}
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.ITreeContentProvider#hasChildren(java.lang.Object)
 		 */
 		@Override
 		public boolean hasChildren(Object element) {
 			if (element instanceof Workspace) {
 				return !((Workspace) element).getProjects().isEmpty();
-			} else if (element instanceof Project) {
+			}
+			else if (element instanceof Project) {
 				return !((Project) element).getChildren(MainCorpus.class).isEmpty();
-			} else if (element instanceof CQPCorpus) {
+			}
+			else if (element instanceof CQPCorpus) {
 				return !((CQPCorpus) element).getProject().getTexts().isEmpty();
-			} else if (element instanceof Text) {
+			}
+			else if (element instanceof Text) {
 				return !((Text) element).getEditions().isEmpty();
-			} else if (element instanceof Edition) {
-				return !((Edition) element).getPages().isEmpty();
-			} else if (element instanceof Page) {
+			}
+			else if (element instanceof Edition) {
+				return !((Edition) element).getPageNames().isEmpty();
+			}
+			else if (element instanceof Page) {
 				return false;
 			}
 			return false;
 		}
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
 		 */
 		@Override
 		public Object[] getElements(Object element) {
 			return getChildren(element);
 		}
-
-		/* (non-Javadoc)
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
 		 */
 		@Override
-		public void dispose() {
-		}
-
-		/* (non-Javadoc)
+		public void dispose() {}
+		
+		/*
+		 * (non-Javadoc)
 		 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
 		 */
 		@Override
-		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
-		}
-
+		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {}
+		
 	}
-
+	
 }
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java	(revision 2731)
@@ -241,7 +241,7 @@
 	 * @param event
 	 * @return
 	 */
-	public static ITXMResultEditor getActiveEditor(ExecutionEvent event) {
+	public static ITXMResultEditor<? extends TXMResult> getActiveEditor(ExecutionEvent event) {
 		
 		IEditorPart editor = null;
 		
@@ -261,7 +261,7 @@
 			return null;
 		}
 		
-		return (ITXMResultEditor) editor;
+		return (ITXMResultEditor<? extends TXMResult>) editor;
 	}
 	
 	/**
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java	(revision 2731)
@@ -133,7 +133,6 @@
 		}
 	}
 	
-	
 	/**
 	 * Gets the parent of the result stored in the active editor.
 	 * This parent will be send to the target command as parent of the new result.
@@ -146,8 +145,6 @@
 		return getActiveEditorResult(event).getParent();
 	}
 	
-	
-	
 	/**
 	 * Logs a severe entry.
 	 * 
@@ -158,25 +155,23 @@
 		return false;
 	}
 	
-	
-	
 	/**
 	 * Executes a command handler specified by its id.
 	 * 
 	 * @param commandId
 	 */
-	public static void executeCommand(String commandId) {
-		executeCommand(commandId, null, null);
+	public static Object executeCommand(String commandId) {
+		return executeCommand(commandId, null, null);
 	}
 	
 	
-	public static void executeCommand(String commandId, Map<String, String> params) {
-		executeCommand(commandId, null, params);
+	public static Object executeCommand(String commandId, Map<String, String> params) {
+		return executeCommand(commandId, null, params);
 	}
 	
 	
-	public static void executeCommand(String commandId, String resultUUID) {
-		executeCommand(commandId, resultUUID, null);
+	public static Object executeCommand(String commandId, String resultUUID) {
+		return executeCommand(commandId, resultUUID, null);
 	}
 	
 	/**
@@ -184,8 +179,9 @@
 	 * 
 	 * @param commandId
 	 * @param resultUUID
+	 * @return
 	 */
-	public static void executeCommand(String commandId, String resultUUID, Map<String, String> params) {
+	public static Object executeCommand(String commandId, String resultUUID, Map<String, String> params) {
 		
 		Log.fine("BaseAbstractHandler.executeCommand(): calling command " + commandId + ".");
 		
@@ -244,12 +240,13 @@
 		// Call the command without parameters
 		else {
 			try {
-				handlerService.executeCommand(cmd.getId(), null);
+				return handlerService.executeCommand(cmd.getId(), null);
 			}
 			catch (Exception e) {
 				e.printStackTrace();
 			}
 		}
+		return null;
 	}
 	
 	
@@ -258,8 +255,8 @@
 	 * 
 	 * @param commandId
 	 */
-	public static void executeSendToCommand(String commandId) {
-		executeSendToCommand(commandId, null);
+	public static Object executeSendToCommand(String commandId) {
+		return executeSendToCommand(commandId, null);
 	}
 	
 	
@@ -270,10 +267,11 @@
 	 * @param commandId
 	 * @param resultParametersNodePath
 	 */
-	public static void executeSendToCommand(String commandId, String resultParametersNodePath) {
+	public static Object executeSendToCommand(String commandId, String resultParametersNodePath) {
 		IContextService contextService = PlatformUI.getWorkbench().getAdapter(IContextService.class);
 		IContextActivation activationToken = contextService.activateContext(SEND_SELECTION_TO_COMMAND_CONTEXT_ID);
-		executeCommand(commandId, resultParametersNodePath);
+		Object o = executeCommand(commandId, resultParametersNodePath);
 		contextService.deactivateContext(activationToken);
+		return o;
 	}
 }
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/ITXMResultEditor.java	(revision 2731)
@@ -1,11 +1,15 @@
 package org.txm.rcp.editors;
 
+import java.util.ArrayList;
+
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.ui.IEditorPart;
+import org.eclipse.ui.part.EditorPart;
 import org.txm.core.results.TXMResult;
 import org.txm.rcp.utils.JobHandler;
 
 public interface ITXMResultEditor<T extends TXMResult> extends IEditorPart {
+	
 	public T getResult();
 	
 	/**
@@ -31,10 +35,21 @@
 	 * Closes the editor from the UI thread and deletes or not the linked result.
 	 */
 	public void close(boolean deleteResult);
-
+	
 	/**
-	 * lock/unlock the editor's result
+	 * lock/unlock the editor's result.
+	 * 
 	 * @param locked
 	 */
 	public void setLocked(boolean locked);
+	
+	public ArrayList<? extends ITXMResultEditor<TXMResult>> getLinkedEditors();
+	
+	public void removeLinkedEditor(ITXMResultEditor<TXMResult> editor);
+	
+	public void addLinkedEditor(ITXMResultEditor<T> editor);
+	
+	public <E extends ITXMResultEditor<TXMResult>> E getLinkedEditor(Class<E> editorClass);
+	
+	public <E extends ITXMResultEditor<TXMResult>> ArrayList<E> getLinkedEditors(Class<E> editorClass);
 }
